



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>django中orm使用的注意事项</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">django中orm使用的注意事项</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 22:19:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>必备小知识点</h2>
<div>
<pre class="prettyprint linenums">&lt;1&gt; all():                 查询所有结果

&lt;2&gt; get(**kwargs):         返回与所给筛选条件相匹配的对象，返回结果有且只有一个，如果符合筛选条件的对象超过一个或者没有都会抛出错误。

&lt;3&gt; filter(**kwargs):      它包含了与所给筛选条件相匹配的对象

&lt;4&gt; exclude(**kwargs):     它包含了与所给筛选条件不匹配的对象

&lt;5&gt; values(*field):        返回一个ValueQuerySet&mdash;&mdash;一个特殊的QuerySet，运行后得到的并不是一系列model的实例化对象，而是一个可迭代的字典序列

&lt;6&gt; values_list(*field):   它与values()非常相似，它返回的是一个元组序列，values返回的是一个字典序列

&lt;7&gt; order_by(*field):      对查询结果排序

&lt;8&gt; reverse():             对查询结果反向排序，请注意reverse()通常只能在具有已定义顺序的QuerySet上调用(在model类的Meta中指定ordering或调用order_by()方法)。

&lt;9&gt; distinct():            从返回结果中剔除重复纪录(如果你查询跨越多个表，可能在计算QuerySet时得到重复的结果。<br />                           此时可以使用distinct()，注意只有在PostgreSQL中支持按字段去重。)

&lt;10&gt; count():              返回数据库中匹配查询(QuerySet)的对象数量。

&lt;11&gt; first():              返回第一条记录

&lt;12&gt; last():               返回最后一条记录

&lt;13&gt; exists():             如果QuerySet包含数据，就返回True，否则返回False</pre>
</div>
<h2>返回QuerySet对象的方法</h2>
<div>
<pre class="prettyprint linenums">all()

filter()

exclude()

order_by()

reverse()

distinct()</pre>
</div>
<h2>特殊的QuerySet对象</h2>
<div>
<pre class="prettyprint linenums">values()       返回一个可迭代的字典序列

values_list() 返回一个可迭代的元祖序列</pre>
</div>
<h2>返回具体对象的</h2>
<div>
<pre class="prettyprint linenums">get()

first()

last()</pre>
</div>
<h2>返回布尔值的方法</h2>
<div>
<pre class="prettyprint linenums">exists()</pre>
</div>
<h2>返回数字的方法</h2>
<div>
<pre class="prettyprint linenums">count()</pre>
</div>
<h2>单表查询之下划线</h2>
<div>
<pre class="prettyprint linenums">models.Tb1.objects.filter(id__lt=10, id__gt=1)   # 获取id大于1 且 小于10的值

models.Tb1.objects.filter(id__in=[11, 22, 33])   # 获取id等于11、22、33的数据<br />
models.Tb1.objects.exclude(id__in=[11, 22, 33])  # not in

models.Tb1.objects.filter(name__contains="ven")  # 获取name字段包含"ven"的<br />
models.Tb1.objects.filter(name__icontains="ven") # icontains大小写不敏感

models.Tb1.objects.filter(id__range=[1, 3])      # id范围是1到3的，等价于SQL的bettwen and

类似的还有：startswith，istartswith, endswith, iendswith　

date字段还可以：<br />
models.Class.objects.filter(first_day__year=2017)</pre>
</div>
<h2>Foreignkey操作</h2>
<h3>正向查找</h3>
<p>按对象查找</p>
<div>
<pre class="prettyprint linenums">语法：<br />
对象.关联字段.字段<br />
book_obj = models.Book.objects.first()  # 第一本书对象<br />
print(book_obj.publisher)  # 得到这本书关联的出版社对象<br />
print(book_obj.publisher.name)  # 得到出版社对象的名称</pre>
</div>
<p>按照字段查找</p>
<div>
<pre class="prettyprint linenums">语法：<br />
关联字段__字段<br />
print(models.Book.objects.values_list("publisher__name"))</pre>
</div>
<h3>反向查找</h3>
<p>按照对象查找</p>
<div>
<pre class="prettyprint linenums">语法：<br />
对象.表名_set<br />
publisher_obj = models.Publisher.objects.first()  # 找到第一个出版社对象<br />
books = publisher_obj.book_set.all()  # 找到第一个出版社出版的所有书<br />
titles = books.values_list("title")  # 找到第一个出版社出版的所有书的书名</pre>
</div>
<p>按照字段查找</p>
<div>
<pre class="prettyprint linenums">语法：<br />
表名__字段<br />
titles = models.Publisher.objects.values_list("book__title")</pre>
</div>
<h2>聚合查询和分组查询</h2>
<p><tt>aggregate()</tt>是<tt>QuerySet</tt>&nbsp;的一个终止子句，意思是说，它返回一个包含一些键值对的字典。</p>
<p>键的名称是聚合值的标识符，值是计算出来的聚合值。键的名称是按照字段和聚合函数的名称自动生成出来的。</p>
<p>用到的内置函数：</p>
<div>
<pre class="prettyprint linenums">from django.db.models import Avg, Sum, Max, Min, Count</pre>
</div>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; from django.db.models import Avg, Sum, Max, Min, Count<br />
&gt;&gt;&gt; models.Book.objects.all().aggregate(Avg("price"))</pre>
</div>
<h2>分组</h2>
<div>
<pre class="prettyprint linenums">我们使用原生SQL语句，按照部门分组求平均工资：<br />
select dept,AVG(salary) from employee group by dept;<br />
ORM查询:<br />
from django.db.models import Avg<br />
Employee.objects.values("dept").annotate(avg=Avg("salary").values("dept", "avg")</pre>
</div>
<p>统计每一本书的作者个数</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; book_list = models.Book.objects.all().annotate(author_num=Count("author"))<br />
&gt;&gt;&gt; for obj in book_list:<br />
...     print(obj.author_num)<br />
...<br />
1</pre>
</div>
<p>统计出每个出版社买的最便宜的书的价格</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; publisher_list = models.Publisher.objects.annotate(min_price=Min("book__price"))<br />
&gt;&gt;&gt; for obj in publisher_list:<br />
...     print(obj.min_price)<br />
...<br />
9.90<br />
19.90</pre>
</div>
<p>统计不止一个作者的图书</p>
<div>
<pre class="prettyprint linenums">models.Book.objects.annotate(author_num=Count("author")).filter(author_num__gt=1)</pre>
</div>
<p>根据一本图书作者数量的多少对查询集&nbsp;<tt>QuerySet</tt>进行排序</p>
<div>
<pre class="prettyprint linenums"> models.Book.objects.annotate(author_num=Count("author")).order_by("author_num")</pre>
</div>
<h2>F查询</h2>
<div>
<pre class="prettyprint linenums">对两个字段的数值进行比较</pre>
</div>
<div>
<pre class="prettyprint linenums">查询评论数大于收藏数的书籍<br />
from django.db.models import F<br />
models.Book.objects.filter(commnet_num__gt=F('keep_num'))</pre>
</div>
<p>修改操作也可以使用F函数,比如将每一本书的价格提高30元</p>
<div>
<pre class="prettyprint linenums">models.Book.objects.all().update(price=F("price")+30)</pre>
</div>
<h2>Q查询</h2>
<div>
<pre class="prettyprint linenums">需要执行更复杂的查询（例如OR语句），你可以使用Q对象。</pre>
</div>
<div>
<pre class="prettyprint linenums">查询作者名是小仙女或小魔女的<br />
models.Book.objects.filter(Q(authors__name="小仙女")|Q(authors__name="小魔女"))</pre>
</div>
<p>你可以组合<tt>&amp;</tt>&nbsp;和<tt>|</tt>&nbsp;&nbsp;操作符以及使用括号进行分组来编写任意复杂的<tt>Q</tt>&nbsp;对象。同时，<tt>Q</tt>&nbsp;对象可以使用<tt>~</tt>&nbsp;操作符取反，这允许组合正常的查询和取反(<tt>NOT</tt>) 查询。</p>
<div>
<pre class="prettyprint linenums">查询作者名字是小仙女并且不是2018年出版的书的书名。<br />
&gt;&gt;&gt; models.Book.objects.filter(Q(author__name="小仙女") &amp; ~Q(publish_date__year=2018)).values_list("title")</pre>
</div>
<h2>事务</h2>
<div>
<pre class="prettyprint linenums">import os

if __name__ == '__main__':<br />
    os.environ.setdefault("DJANGO_SETTINGS_MODULE", "BMS.settings")<br />
    import django<br />
    django.setup()

    import datetime<br />
    from app01 import models

    try:<br />
        from django.db import transaction<br />
        with transaction.atomic():<br />
            new_publisher = models.Publisher.objects.create(name="火星出版社")<br />
            models.Book.objects.create(title="橘子物语", publish_date=datetime.date.today(), publisher_id=10)  # 指定一个不存在的出版社id<br />
    except Exception as e:<br />
        print(str(e))</pre>
</div>
<h2>Django ORM执行原生SQL</h2>
<div>
<pre class="prettyprint linenums"># extra<br />
# 在QuerySet的基础上继续执行子语句<br />
# extra(self, select=None, where=None, params=None, tables=None, order_by=None, select_params=None)

# select和select_params是一组，where和params是一组，tables用来设置from哪个表<br />
# Entry.objects.extra(select={'new_id': "select col from sometable where othercol &gt; %s"}, select_params=(1,))<br />
# Entry.objects.extra(where=['headline=%s'], params=['Lennon'])<br />
# Entry.objects.extra(where=["foo='a' OR bar = 'a'", "baz = 'a'"])<br />
# Entry.objects.extra(select={'new_id': "select id from tb where id &gt; %s"}, select_params=(1,), order_by=['-nid'])

举个例子：<br />
models.UserInfo.objects.extra(<br />
                    select={'newid':'select count(1) from app01_usertype where id&gt;%s'},<br />
                    select_params=[1,],<br />
                    where = ['age&gt;%s'],<br />
                    params=[18,],<br />
                    order_by=['-age'],<br />
                    tables=['app01_usertype']<br />
                )<br />
                """<br />
                select<br />
                    app01_userinfo.id,<br />
                    (select count(1) from app01_usertype where id&gt;1) as newid<br />
                from app01_userinfo,app01_usertype<br />
                where<br />
                    app01_userinfo.age &gt; 18<br />
                order by<br />
                    app01_userinfo.age desc<br />
                """

# 执行原生SQL<br />
# 更高灵活度的方式执行原生SQL语句<br />
# from django.db import connection, connections<br />
# cursor = connection.cursor()  # cursor = connections['default'].cursor()<br />
# cursor.execute("""SELECT * from auth_user where id = %s""", [1])<br />
# row = cursor.fetchone()

ORM 执行原生SQL的方法</pre>
</div>
<h2>QuerySet方法大全</h2>
<div>
<pre class="prettyprint linenums">##################################################################<br />
# PUBLIC METHODS THAT ALTER ATTRIBUTES AND RETURN A NEW QUERYSET #<br />
##################################################################

def all(self)<br />
    # 获取所有的数据对象

def filter(self, *args, **kwargs)<br />
    # 条件查询<br />
    # 条件可以是：参数，字典，Q

def exclude(self, *args, **kwargs)<br />
    # 条件查询<br />
    # 条件可以是：参数，字典，Q

def select_related(self, *fields)<br />
    性能相关：表之间进行join连表操作，一次性获取关联的数据。

    总结：<br />
    1. select_related主要针一对一和多对一关系进行优化。<br />
    2. select_related使用SQL的JOIN语句进行优化，通过减少SQL查询的次数来进行优化、提高性能。

def prefetch_related(self, *lookups)<br />
    性能相关：多表连表操作时速度会慢，使用其执行多次SQL查询在Python代码中实现连表操作。

    总结：<br />
    1. 对于多对多字段（ManyToManyField）和一对多字段，可以使用prefetch_related()来进行优化。<br />
    2. prefetch_related()的优化方式是分别查询每个表，然后用Python处理他们之间的关系。

def annotate(self, *args, **kwargs)<br />
    # 用于实现聚合group by查询

    from django.db.models import Count, Avg, Max, Min, Sum

    v = models.UserInfo.objects.values('u_id').annotate(uid=Count('u_id'))<br />
    # SELECT u_id, COUNT(ui) AS `uid` FROM UserInfo GROUP BY u_id

    v = models.UserInfo.objects.values('u_id').annotate(uid=Count('u_id')).filter(uid__gt=1)<br />
    # SELECT u_id, COUNT(ui_id) AS `uid` FROM UserInfo GROUP BY u_id having count(u_id) &gt; 1

    v = models.UserInfo.objects.values('u_id').annotate(uid=Count('u_id',distinct=True)).filter(uid__gt=1)<br />
    # SELECT u_id, COUNT( DISTINCT ui_id) AS `uid` FROM UserInfo GROUP BY u_id having count(u_id) &gt; 1

def distinct(self, *field_names)<br />
    # 用于distinct去重<br />
    models.UserInfo.objects.values('nid').distinct()<br />
    # select distinct nid from userinfo

    注：只有在PostgreSQL中才能使用distinct进行去重

def order_by(self, *field_names)<br />
    # 用于排序<br />
    models.UserInfo.objects.all().order_by('-id','age')

def extra(self, select=None, where=None, params=None, tables=None, order_by=None, select_params=None)<br />
    # 构造额外的查询条件或者映射，如：子查询

    Entry.objects.extra(select={'new_id': "select col from sometable where othercol &gt; %s"}, select_params=(1,))<br />
    Entry.objects.extra(where=['headline=%s'], params=['Lennon'])<br />
    Entry.objects.extra(where=["foo='a' OR bar = 'a'", "baz = 'a'"])<br />
    Entry.objects.extra(select={'new_id': "select id from tb where id &gt; %s"}, select_params=(1,), order_by=['-nid'])

 def reverse(self):<br />
    # 倒序<br />
    models.UserInfo.objects.all().order_by('-nid').reverse()<br />
    # 注：如果存在order_by，reverse则是倒序，如果多个排序则一一倒序

 def defer(self, *fields):<br />
    models.UserInfo.objects.defer('username','id')<br />
    或<br />
    models.UserInfo.objects.filter(...).defer('username','id')<br />
    #映射中排除某列数据

 def only(self, *fields):<br />
    #仅取某个表中的数据<br />
     models.UserInfo.objects.only('username','id')<br />
     或<br />
     models.UserInfo.objects.filter(...).only('username','id')

 def using(self, alias):<br />
     指定使用的数据库，参数为别名（setting中的设置）

##################################################<br />
# PUBLIC METHODS THAT RETURN A QUERYSET SUBCLASS #<br />
##################################################

def raw(self, raw_query, params=None, translations=None, using=None):<br />
    # 执行原生SQL<br />
    models.UserInfo.objects.raw('select * from userinfo')

    # 如果SQL是其他表时，必须将名字设置为当前UserInfo对象的主键列名<br />
    models.UserInfo.objects.raw('select id as nid from 其他表')

    # 为原生SQL设置参数<br />
    models.UserInfo.objects.raw('select id as nid from userinfo where nid&gt;%s', params=[12,])

    # 将获取的到列名转换为指定列名<br />
    name_map = {'first': 'first_name', 'last': 'last_name', 'bd': 'birth_date', 'pk': 'id'}<br />
    Person.objects.raw('SELECT * FROM some_other_table', translations=name_map)

    # 指定数据库<br />
    models.UserInfo.objects.raw('select * from userinfo', using="default")

    ################### 原生SQL ###################<br />
    from django.db import connection, connections<br />
    cursor = connection.cursor()  # cursor = connections['default'].cursor()<br />
    cursor.execute("""SELECT * from auth_user where id = %s""", [1])<br />
    row = cursor.fetchone() # fetchall()/fetchmany(..)

def values(self, *fields):<br />
    # 获取每行数据为字典格式

def values_list(self, *fields, **kwargs):<br />
    # 获取每行数据为元祖

def dates(self, field_name, kind, order='ASC'):<br />
    # 根据时间进行某一部分进行去重查找并截取指定内容<br />
    # kind只能是："year"（年）, "month"（年-月）, "day"（年-月-日）<br />
    # order只能是："ASC"  "DESC"<br />
    # 并获取转换后的时间<br />
        - year : 年-01-01<br />
        - month: 年-月-01<br />
        - day  : 年-月-日

    models.DatePlus.objects.dates('ctime','day','DESC')

def datetimes(self, field_name, kind, order='ASC', tzinfo=None):<br />
    # 根据时间进行某一部分进行去重查找并截取指定内容，将时间转换为指定时区时间<br />
    # kind只能是 "year", "month", "day", "hour", "minute", "second"<br />
    # order只能是："ASC"  "DESC"<br />
    # tzinfo时区对象<br />
    models.DDD.objects.datetimes('ctime','hour',tzinfo=pytz.UTC)<br />
    models.DDD.objects.datetimes('ctime','hour',tzinfo=pytz.timezone('Asia/Shanghai'))

    """<br />
    pip3 install pytz<br />
    import pytz<br />
    pytz.all_timezones<br />
    pytz.timezone(&lsquo;Asia/Shanghai&rsquo;)<br />
    """

def none(self):<br />
    # 空QuerySet对象

####################################<br />
# METHODS THAT DO DATABASE QUERIES #<br />
####################################

def aggregate(self, *args, **kwargs):<br />
   # 聚合函数，获取字典类型聚合结果<br />
   from django.db.models import Count, Avg, Max, Min, Sum<br />
   result = models.UserInfo.objects.aggregate(k=Count('u_id', distinct=True), n=Count('nid'))<br />
   ===&gt; {'k': 3, 'n': 4}

def count(self):<br />
   # 获取个数

def get(self, *args, **kwargs):<br />
   # 获取单个对象

def create(self, **kwargs):<br />
   # 创建对象

def bulk_create(self, objs, batch_size=None):<br />
    # 批量插入<br />
    # batch_size表示一次插入的个数<br />
    objs = [<br />
        models.DDD(name='r11'),<br />
        models.DDD(name='r22')<br />
    ]<br />
    models.DDD.objects.bulk_create(objs, 10)

def get_or_create(self, defaults=None, **kwargs):<br />
    # 如果存在，则获取，否则，创建<br />
    # defaults 指定创建时，其他字段的值<br />
    obj, created = models.UserInfo.objects.get_or_create(username='root1', defaults={'email': '','u_id': 2, 't_id': 2})

def update_or_create(self, defaults=None, **kwargs):<br />
    # 如果存在，则更新，否则，创建<br />
    # defaults 指定创建时或更新时的其他字段<br />
    obj, created = models.UserInfo.objects.update_or_create(username='root1', defaults={'email': '','u_id': 2, 't_id': 1})

def first(self):<br />
   # 获取第一个

def last(self):<br />
   # 获取最后一个

def in_bulk(self, id_list=None):<br />
   # 根据主键ID进行查找<br />
   id_list = [11,21,31]<br />
   models.DDD.objects.in_bulk(id_list)

def delete(self):<br />
   # 删除

def update(self, **kwargs):<br />
    # 更新

def exists(self):<br />
   # 是否有结果

QuerySet方法大全</pre>
</div>
<h2>Django终端打印SQL语句</h2>
<p>在Django项目的settings.py文件中，在最后复制粘贴如下代码：</p>
<div></p>
<p>LOGGING = {<br />    'version': 1,<br />    'disable_existing_loggers': False,<br />    'handlers': {<br />        'console':{<br />            'level':'DEBUG',<br />            'class':'logging.StreamHandler',<br />        },<br />    },<br />    'loggers': {<br />        'django.db.backends': {<br />            'handlers': ['console'],<br />            'propagate': True,<br />            'level':'DEBUG',<br />        },<br />    }<br />}</p>
</div>
<p>即为你的Django项目配置上一个名为<em>django.db.backends</em>的logger实例即可查看翻译后的SQL语句。</p>
<h2>在Python脚本中调用Django环境</h2>
<div>
<pre class="prettyprint linenums">import os

if __name__ == '__main__':<br />
    os.environ.setdefault("DJANGO_SETTINGS_MODULE", "BMS.settings")<br />
    import django<br />
    django.setup()

    from app01 import models

    books = models.Book.objects.all()<br />
    print(books)</pre>
</div>
<h2>总结</h2>
<div>
<pre class="prettyprint linenums">mysql的配置<br />
            1. 创建mysql数据库<br />
            2. settings配置<br />
                ENGINE:    'mysql'<br />
                NAME: '数据库名称'<br />
                HOST：IP<br />
                PORT: 3306<br />
                USER: 'root'<br />
                PASSWORD: ''

            3. 告诉django使用pymysql来连接mysql数据库<br />
                在项目同名的文件夹下的__init__.py中写：<br />
                    import pymysql<br />
                    pymysql.install_as_MySQLdb()

            4. 创建model<br />
                class Person(models.Model)<br />
                    name = models.CharField(max_length=32)

            5. 执行两条数据库命令<br />
                python manage.py makemigrations   # 记录models的变更记录<br />
                python manage.py migrate         # 把变革记录更新到数据库中</pre>
</div>
<div>
<pre class="prettyprint linenums">ORM操作

            1. 查<br />
                models.Person.objects.all()  # 查所有<br />
                models.Person.objects.get(id=1,name='xxx')    # 查一个对象 满足条件的<br />
                models.Person.objects.filter(id=1,name='xxx')  # 查询满足条件的所有对象 列表<br />
                models.Person.objects.filter(id=1,name='xxx').order_by('id')  

                属性：<br />
                    pub_obj.name

                    外键的 book<br />
                    book_obj.name<br />
                    book_obj.publisher   &mdash;&mdash;》 这是书籍关联的出版社对象<br />
                    book_obj.publisher_id   &mdash;&mdash;》 这是数据库存的数据<br />
                    book_obj.publisher.id<br />
                    book_obj.publisher.name 

                    多对多 author

                    author.name

                    author.books    &mdash;&mdash;》 多对多的管理对象<br />
                    author.books.all()   所有作者关联的书籍对象列表 

            2. 增加：<br />
                models.Publisher.objects.creatte(name='xxxx')

                外键<br />
                models.Book.objects.creatte(name='xxxx',publisher=pub_obj)<br />
                models.Book.objects.creatte(name='xxxx',publisher_id=pub_obj.id)

                多对多

                author_obj = models.Author.objects.creatte(name='xxx')<br />
                author_obj.books.set([1,2,3])

            3. 删除<br />
                models.Publisher.objects.get(id=1).delete()<br />
                models.Publisher.objects.filter(id=1).delete

            4. 修改

                pub_obj.name = new_name<br />
                pub_obj.save()

                book_obj.name= new_name<br />
                book_obj.publisher = new_pub_obj<br />
                book_obj.publisher_id = 2<br />
                book_obj.save()

                author_obj.name=new_name<br />
                author_obj.save()<br />
                author_obj.books.set([1,2])</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o4jz5q.html">MYSQL进阶，新手变司机</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rmyne8.html">网络流 poj 3308 最小割</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2150l8.html">手机触屏触摸特效javascript-TouchSwipe（依赖于jquery库）中文说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq417jnq.html">JSON 数组的遍历解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4gzmq.html">【Python学习笔记】循环和迭代</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zwmj49.html">PAT-乙级-1015&period; 德才论 &lpar;25&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1zwy39.html">UI中的七种手势</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdxd548.html">QT中使用Glut库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gerkw78.html">Pycharm，Python原生IDE&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgmzje8.html">assert断言</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1lo6w9.html">Shiro授权管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdgpne9.html">Scala之隐式转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7opjve8.html">windows 下 MyEclipse 逆向工程生成hiberate 对应配置文件以及 javaBean。</a>
		</li>
						<li><a href="https://www.batexi.com/a/902157mq.html">www&period;sojson&period;com网站高级JS加密破解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kozy36q.html">mac下安装apache tomcat</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvjwkgq.html">ubuntu16&period;04 tensorflow   pip 方式安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1rmxe9.html">solr特点八&colon;Spatial&lpar;空间搜索&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k4zv3q.html">GoBelieve service部署常见问题总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmwgz09.html">内存不够清理方法，costdown项目时如果裁剪不下来，也可以参考</a>
		</li>
						<li><a href="https://www.batexi.com/a/902z3loq.html">WMI技术介绍和应用&mdash;&mdash;WMI概述</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2wply9.html">java版迷宫</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll0rx1q.html">报错解决&mdash;&mdash;-bash&colon; wget&colon; command not found</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j1o5nq.html">what&amp;&num;39&semi;s the python之if判断、while循环以及for循环</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rx7058.html">Delphi INI文件保存与读取</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2w4xo9.html">request&period;getSession&lpar;true&rpar;和request&period;getSession&lpar;false&rpar;的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o16ox8.html">Spark MLlib之水塘抽样算法（Reservoir Sampling）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w1ergq.html">Golang--Hello World</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rxeo08.html">别再说找不到Python练手项目了，这80个拿去过冬</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll0yzxq.html">MacBook PyCharm永久激活</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy3epjq.html">Tensorflow实现手写体分类（含dropout）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
